<?xml version="1.0" encoding="UTF-8"?>
<jube>
  <include-path>
  <!--  platforms -->
  <path tag="galileo100">../../platforms/galileo100</path>
  <path tag="marconi100">../../platforms/marconi100</path>
  <path tag="leonardo">../../platforms/leonardo</path>
  <path tag="marenostrum">../../platforms/marenostrumIV</path>
  <path tag="ariodante">../../platforms/ariodante</path>
  <!--  workloads -->
  <path tag="si_fatbands">../../workloads/siesta/si_fatbands</path>
  <path tag="si-quantum-dot">../../workloads/siesta/si-quantum-dot</path>
  <path tag="sih">../../workloads/siesta/sih</path>
  <path tag="water">../../workloads/siesta/water</path>
  <path tag="dna">../../workloads/siesta/dna</path>
  <path tag="gold-water">../../workloads/siesta/gold-water</path>
  <path tag="gold-water-weak">../../workloads/siesta/gold-water-weak</path>
  <path tag="covid-12k-diag">../../workloads/siesta/covid-12k-diag</path>
  <path tag="covid-8k-pexsi">../../workloads/siesta/covid-8k-pexsi</path>
  </include-path>

  <benchmark name="sample_benchmark" outpath="bench_run">
    <comment>Template for generic benchmark</comment>    

    <!-- no. of nodes, tasks, etc -->
    <parameterset name="systemParameter" init_with="platform.xml">
    <parameter name="nodes" type="int" default="1">1</parameter>
    <parameter name="taskspernode" type="int" default="4">2,4</parameter>
    <parameter name="threadspertask">8</parameter>
    <parameter name="taskspersocket">2</parameter>
    <parameter name="ncores" type="int">8</parameter>
    <parameter name="accountno" >cin_staff</parameter>
    <parameter name="executable">siesta</parameter>
    <parameter name="args_executable"> $fin > $fout </parameter>
    <parameter name="timelimit">01:00:00</parameter>
    <parameter name="gres" separator=";">gpu:4</parameter>
    <parameter name="ready_file">ready</parameter>
    </parameterset>

   <!-- running the job, llsubmit, runjob , etc -->
    <parameterset name="executeset" init_with="platform.xml">
    <parameter name="modules">ml siesta-full-build-gcc-12.2.0-tw7axd4</parameter>
    </parameterset>

    <!-- testcase parameters -->
    <parameterset name="testcaseset" init_with="workload.xml">
    </parameterset>

    <!-- files needed incl job file and input files -->
    <fileset name="jobfiles" init_with="platform.xml">
      <copy>$jube_benchmark_home/../../workloads/siesta/$dirin/*</copy>
    </fileset>

    <!-- Substitute jobfile -->
    <substituteset name="executesub" init_with="platform.xml">
    <sub source="#ACCOUNT_NO#" dest="$accountno" />
    <sub source="#PREPROCESS#" dest="$modules" />
    <sub source="#MINMEM#" dest="$minmem" />
    <sub source="#READY#" dest="$ready_file" />
    </substituteset>

    <!-- testcase fdf options -->
    <substituteset name="fdfsub" init_with="workload.xml">
    </substituteset>

    <!-- Operation -->
    <step name="submit"  >
      <use>testcaseset</use>
      <use>systemParameter</use>
      <use>executeset</use>
      <use>jobfiles</use>
      <use>executesub</use>
      <use>fdfsub</use>
      <do>$submit $submit_script</do> <!-- actual submission directive -->
    </step>    

    <patternset name="pattern">
       <pattern name="walltime" type="float"></pattern>
    </patternset>

    <analyser name="analyse">
      <use>pattern</use>
      <analyse step="submit">
        <file>$fout</file>
      </analyse>
    </analyser>

    <result>
      <use>analyse</use>
      <table name="result" style="pretty" sort="nodes" tag="!csv">
        <column title="Nodes">nodes</column>
        <column title="Tasks/Node">taskspernode</column>
        <column title="Threads/Task">threadspertask</column>
        <column format=".2f" title="walltime">walltime</column>
      </table>
   </result>
  </benchmark>
</jube>
